Index: palm/trunk/SOURCE/land_surface_model.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model.f90	(revision 1584)
+++ palm/trunk/SOURCE/land_surface_model.f90	(revision 1585)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Modifications for RRTMG. Changed tables to PARAMETER type. 
 ! 
 ! Former revisions:
@@ -80,5 +80,5 @@
 !------------------------------------------------------------------------------!
      USE arrays_3d,                                                            &
-         ONLY:  pt, pt_p, q, q_p, qsws, rif, shf, ts, us, z0, z0h
+         ONLY:  pt, pt_p, q_p, qsws, rif, shf, ts, us, z0, z0h
 
      USE cloud_parameters,                                                     &
@@ -90,8 +90,8 @@
                 max_masks, precipitation, pt_surface, rho_surface,             &
                 roughness_length, surface_pressure, timestep_scheme, tsc,      &
-                z0h_factor
+                z0h_factor, time_since_reference_point
 
      USE indices,                                                              &
-         ONLY:  nxlg, nxrg, nyng, nysg, nzb_s_inner 
+         ONLY:  nbgp, nxlg, nxrg, nyng, nysg, nzb, nzb_s_inner 
 
      USE kinds
@@ -101,5 +101,5 @@
 
      USE radiation_model_mod,                                                  &
-         ONLY:  irad_scheme, rad_net, rad_sw_in, sigma_sb
+         ONLY:  radiation_scheme, rad_net, rad_sw_in, sigma_sb
 
      USE statistics,                                                           &
@@ -243,4 +243,5 @@
               qsws_veg_eb,      & !: surface flux of latent heat (vegetation portion)
               qsws_veg_eb_av,   & !: average of qsws_veg_eb
+              rad_net_l,        & !: local copy of rad_net (net radiation at surface)
               r_a,              & !: aerodynamic resistance 
               r_a_av,           & !: avergae of r_a
@@ -276,6 +277,4 @@
               t_soil_av, t_soil_1, t_soil_2,                                   &
               m_soil_av, m_soil_1, m_soil_2
-
-
 #endif
 
@@ -289,39 +288,39 @@
 !
 !-- Predefined Land surface classes (veg_type)
-    CHARACTER(26), DIMENSION(0:19) :: veg_type_name = (/          &
-                                   'user defined',                & ! 0 
-                                   'crops, mixed farming',        & !  1
-                                   'short grass',                 & !  2
-                                   'evergreen needleleaf trees',  & !  3
-                                   'deciduous needleleaf trees',  & !  4
-                                   'evergreen broadleaf trees' ,  & !  5
-                                   'deciduous broadleaf trees',   & !  6
-                                   'tall grass',                  & !  7
-                                   'desert',                      & !  8
-                                   'tundra',                      & !  9
-                                   'irrigated crops',             & ! 10
-                                   'semidesert',                  & ! 11
-                                   'ice caps and glaciers' ,      & ! 12
-                                   'bogs and marshes',            & ! 13
-                                   'inland water',                & ! 14
-                                   'ocean',                       & ! 15
-                                   'evergreen shrubs',            & ! 16
-                                   'deciduous shrubs',            & ! 17
-                                   'mixed forest/woodland',       & ! 18
-                                   'interrupted forest'           & ! 19
-                                                       /)
+    CHARACTER(26), DIMENSION(0:19), PARAMETER :: veg_type_name = (/ &
+                                   'user defined',                  & ! 0 
+                                   'crops, mixed farming',          & !  1
+                                   'short grass',                   & !  2
+                                   'evergreen needleleaf trees',    & !  3
+                                   'deciduous needleleaf trees',    & !  4
+                                   'evergreen broadleaf trees' ,    & !  5
+                                   'deciduous broadleaf trees',     & !  6
+                                   'tall grass',                    & !  7
+                                   'desert',                        & !  8
+                                   'tundra',                        & !  9
+                                   'irrigated crops',               & ! 10
+                                   'semidesert',                    & ! 11
+                                   'ice caps and glaciers' ,        & ! 12
+                                   'bogs and marshes',              & ! 13
+                                   'inland water',                  & ! 14
+                                   'ocean',                         & ! 15
+                                   'evergreen shrubs',              & ! 16
+                                   'deciduous shrubs',              & ! 17
+                                   'mixed forest/woodland',         & ! 18
+                                   'interrupted forest'             & ! 19
+                                                                 /)
 
 !
 !-- Soil model classes (soil_type)
-    CHARACTER(12), DIMENSION(0:7) :: soil_type_name = (/ &
-                                   'user defined',        & ! 0 
-                                   'coarse',              & ! 1
-                                   'medium',              & ! 2
-                                   'medium-fine',         & ! 3
-                                   'fine',                & ! 4
-                                   'very fine' ,          & ! 5
-                                   'organic',             & ! 6
-                                   'loamy (CH)'           & ! 7
-                                                        /)
+    CHARACTER(12), DIMENSION(0:7), PARAMETER :: soil_type_name = (/ &
+                                   'user defined',                  & ! 0 
+                                   'coarse',                        & ! 1
+                                   'medium',                        & ! 2
+                                   'medium-fine',                   & ! 3
+                                   'fine',                          & ! 4
+                                   'very fine' ,                    & ! 5
+                                   'organic',                       & ! 6
+                                   'loamy (CH)'                     & ! 7
+                                                                 /)
 !
 !-- Land surface parameters according to the respective classes (veg_type)
@@ -330,96 +329,96 @@
 !-- Land surface parameters I
 !--                          r_canopy_min,     lai,   c_veg,     g_d
-    REAL(wp), DIMENSION(0:3,1:19) :: veg_pars = RESHAPE( (/           &
-                                 180.0_wp, 3.00_wp, 0.90_wp, 0.00_wp, & !  1
-                                 110.0_wp, 2.00_wp, 0.85_wp, 0.00_wp, & !  2
-                                 500.0_wp, 5.00_wp, 0.90_wp, 0.03_wp, & !  3
-                                 500.0_wp, 5.00_wp, 0.90_wp, 0.03_wp, & !  4
-                                 175.0_wp, 5.00_wp, 0.90_wp, 0.03_wp, & !  5
-                                 240.0_wp, 6.00_wp, 0.99_wp, 0.13_wp, & !  6
-                                 100.0_wp, 2.00_wp, 0.70_wp, 0.00_wp, & !  7
-                                 250.0_wp, 0.05_wp, 0.00_wp, 0.00_wp, & !  8
-                                  80.0_wp, 1.00_wp, 0.50_wp, 0.00_wp, & !  9
-                                 180.0_wp, 3.00_wp, 0.90_wp, 0.00_wp, & ! 10
-                                 150.0_wp, 0.50_wp, 0.10_wp, 0.00_wp, & ! 11
-                                   0.0_wp, 0.00_wp, 0.00_wp, 0.00_wp, & ! 12
-                                 240.0_wp, 4.00_wp, 0.60_wp, 0.00_wp, & ! 13
-                                   0.0_wp, 0.00_wp, 0.00_wp, 0.00_wp, & ! 14
-                                   0.0_wp, 0.00_wp, 0.00_wp, 0.00_wp, & ! 15
-                                 225.0_wp, 3.00_wp, 0.50_wp, 0.00_wp, & ! 16
-                                 225.0_wp, 1.50_wp, 0.50_wp, 0.00_wp, & ! 17
-                                 250.0_wp, 5.00_wp, 0.90_wp, 0.03_wp, & ! 18
-                                 175.0_wp, 2.50_wp, 0.90_wp, 0.03_wp  & ! 19
+    REAL(wp), DIMENSION(0:3,1:19), PARAMETER :: veg_pars = RESHAPE( (/ &
+                                 180.0_wp, 3.00_wp, 0.90_wp, 0.00_wp,  & !  1
+                                 110.0_wp, 2.00_wp, 0.85_wp, 0.00_wp,  & !  2
+                                 500.0_wp, 5.00_wp, 0.90_wp, 0.03_wp,  & !  3
+                                 500.0_wp, 5.00_wp, 0.90_wp, 0.03_wp,  & !  4
+                                 175.0_wp, 5.00_wp, 0.90_wp, 0.03_wp,  & !  5
+                                 240.0_wp, 6.00_wp, 0.99_wp, 0.13_wp,  & !  6
+                                 100.0_wp, 2.00_wp, 0.70_wp, 0.00_wp,  & !  7
+                                 250.0_wp, 0.05_wp, 0.00_wp, 0.00_wp,  & !  8
+                                  80.0_wp, 1.00_wp, 0.50_wp, 0.00_wp,  & !  9
+                                 180.0_wp, 3.00_wp, 0.90_wp, 0.00_wp,  & ! 10
+                                 150.0_wp, 0.50_wp, 0.10_wp, 0.00_wp,  & ! 11
+                                   0.0_wp, 0.00_wp, 0.00_wp, 0.00_wp,  & ! 12
+                                 240.0_wp, 4.00_wp, 0.60_wp, 0.00_wp,  & ! 13
+                                   0.0_wp, 0.00_wp, 0.00_wp, 0.00_wp,  & ! 14
+                                   0.0_wp, 0.00_wp, 0.00_wp, 0.00_wp,  & ! 15
+                                 225.0_wp, 3.00_wp, 0.50_wp, 0.00_wp,  & ! 16
+                                 225.0_wp, 1.50_wp, 0.50_wp, 0.00_wp,  & ! 17
+                                 250.0_wp, 5.00_wp, 0.90_wp, 0.03_wp,  & ! 18
+                                 175.0_wp, 2.50_wp, 0.90_wp, 0.03_wp   & ! 19
                                  /), (/ 4, 19 /) )
 
 !
 !-- Land surface parameters II          z0,         z0h
-    REAL(wp), DIMENSION(0:1,1:19) :: roughness_par = RESHAPE( (/ & 
-                                   0.25_wp,  0.25E-2_wp,         & !  1
-                                   0.20_wp,  0.20E-2_wp,         & !  2
-                                   2.00_wp,     2.00_wp,         & !  3
-                                   2.00_wp,     2.00_wp,         & !  4
-                                   2.00_wp,     2.00_wp,         & !  5
-                                   2.00_wp,     2.00_wp,         & !  6
-                                   0.47_wp,  0.47E-2_wp,         & !  7
-                                  0.013_wp, 0.013E-2_wp,         & !  8
-                                  0.034_wp, 0.034E-2_wp,         & !  9
-                                    0.5_wp,  0.50E-2_wp,         & ! 10
-                                   0.17_wp,  0.17E-2_wp,         & ! 11
-                                 1.3E-3_wp,   1.3E-4_wp,         & ! 12
-                                   0.83_wp,  0.83E-2_wp,         & ! 13
-                                   0.00_wp,  0.00E-2_wp,         & ! 14
-                                   0.00_wp,  0.00E-2_wp,         & ! 15
-                                   0.10_wp,  0.10E-2_wp,         & ! 16
-                                   0.25_wp,  0.25E-2_wp,         & ! 17
-                                   2.00_wp,  2.00E-2_wp,         & ! 18
-                                   1.10_wp,  1.10E-2_wp          & ! 19
+    REAL(wp), DIMENSION(0:1,1:19), PARAMETER :: roughness_par = RESHAPE( (/ & 
+                                   0.25_wp,  0.25E-2_wp,                    & !  1
+                                   0.20_wp,  0.20E-2_wp,                    & !  2
+                                   2.00_wp,     2.00_wp,                    & !  3
+                                   2.00_wp,     2.00_wp,                    & !  4
+                                   2.00_wp,     2.00_wp,                    & !  5
+                                   2.00_wp,     2.00_wp,                    & !  6
+                                   0.47_wp,  0.47E-2_wp,                    & !  7
+                                  0.013_wp, 0.013E-2_wp,                    & !  8
+                                  0.034_wp, 0.034E-2_wp,                    & !  9
+                                    0.5_wp,  0.50E-2_wp,                    & ! 10
+                                   0.17_wp,  0.17E-2_wp,                    & ! 11
+                                 1.3E-3_wp,   1.3E-4_wp,                    & ! 12
+                                   0.83_wp,  0.83E-2_wp,                    & ! 13
+                                   0.00_wp,  0.00E-2_wp,                    & ! 14
+                                   0.00_wp,  0.00E-2_wp,                    & ! 15
+                                   0.10_wp,  0.10E-2_wp,                    & ! 16
+                                   0.25_wp,  0.25E-2_wp,                    & ! 17
+                                   2.00_wp,  2.00E-2_wp,                    & ! 18
+                                   1.10_wp,  1.10E-2_wp                     & ! 19
                                  /), (/ 2, 19 /) )
 
 !
 !-- Land surface parameters III lambda_surface_s, lambda_surface_u, f_sw_in
-    REAL(wp), DIMENSION(0:2,1:19) :: surface_pars = RESHAPE( (/           &
-                                      10.0_wp,       10.0_wp, 0.05_wp, & !  1
-                                      10.0_wp,       10.0_wp, 0.05_wp, & !  2
-                                      20.0_wp,       15.0_wp, 0.03_wp, & !  3
-                                      20.0_wp,       15.0_wp, 0.03_wp, & !  4
-                                      20.0_wp,       15.0_wp, 0.03_wp, & !  5
-                                      20.0_wp,       15.0_wp, 0.03_wp, & !  6
-                                      10.0_wp,       10.0_wp, 0.05_wp, & !  7
-                                      15.0_wp,       15.0_wp, 0.00_wp, & !  8
-                                      10.0_wp,       10.0_wp, 0.05_wp, & !  9
-                                      10.0_wp,       10.0_wp, 0.05_wp, & ! 10 
-                                      10.0_wp,       10.0_wp, 0.05_wp, & ! 11
-                                      58.0_wp,       58.0_wp, 0.00_wp, & ! 12
-                                      10.0_wp,       10.0_wp, 0.05_wp, & ! 13 
-                                    1.0E20_wp,     1.0E20_wp, 0.00_wp, & ! 14
-                                    1.0E20_wp,     1.0E20_wp, 0.00_wp, & ! 15
-                                      10.0_wp,       10.0_wp, 0.05_wp, & ! 16
-                                      10.0_wp,       10.0_wp, 0.05_wp, & ! 17
-                                      20.0_wp,       15.0_wp, 0.03_wp, & ! 18
-                                      20.0_wp,       15.0_wp, 0.03_wp  & ! 19
+    REAL(wp), DIMENSION(0:2,1:19), PARAMETER :: surface_pars = RESHAPE( (/ &
+                                      10.0_wp,       10.0_wp, 0.05_wp,     & !  1
+                                      10.0_wp,       10.0_wp, 0.05_wp,     & !  2
+                                      20.0_wp,       15.0_wp, 0.03_wp,     & !  3
+                                      20.0_wp,       15.0_wp, 0.03_wp,     & !  4
+                                      20.0_wp,       15.0_wp, 0.03_wp,     & !  5
+                                      20.0_wp,       15.0_wp, 0.03_wp,     & !  6
+                                      10.0_wp,       10.0_wp, 0.05_wp,     & !  7
+                                      15.0_wp,       15.0_wp, 0.00_wp,     & !  8
+                                      10.0_wp,       10.0_wp, 0.05_wp,     & !  9
+                                      10.0_wp,       10.0_wp, 0.05_wp,     & ! 10 
+                                      10.0_wp,       10.0_wp, 0.05_wp,     & ! 11
+                                      58.0_wp,       58.0_wp, 0.00_wp,     & ! 12
+                                      10.0_wp,       10.0_wp, 0.05_wp,     & ! 13 
+                                    1.0E20_wp,     1.0E20_wp, 0.00_wp,     & ! 14
+                                    1.0E20_wp,     1.0E20_wp, 0.00_wp,     & ! 15
+                                      10.0_wp,       10.0_wp, 0.05_wp,     & ! 16
+                                      10.0_wp,       10.0_wp, 0.05_wp,     & ! 17
+                                      20.0_wp,       15.0_wp, 0.03_wp,     & ! 18
+                                      20.0_wp,       15.0_wp, 0.03_wp      & ! 19
                                       /), (/ 3, 19 /) )
 
 !
 !-- Root distribution (sum = 1)  level 1, level 2, level 3, level 4,
-    REAL(wp), DIMENSION(0:3,1:19) :: root_distribution = RESHAPE( (/ &
-                                 0.24_wp, 0.41_wp, 0.31_wp, 0.04_wp, & !  1
-                                 0.35_wp, 0.38_wp, 0.23_wp, 0.04_wp, & !  2
-                                 0.26_wp, 0.39_wp, 0.29_wp, 0.06_wp, & !  3
-                                 0.26_wp, 0.38_wp, 0.29_wp, 0.07_wp, & !  4
-                                 0.24_wp, 0.38_wp, 0.31_wp, 0.07_wp, & !  5
-                                 0.25_wp, 0.34_wp, 0.27_wp, 0.14_wp, & !  6
-                                 0.27_wp, 0.27_wp, 0.27_wp, 0.09_wp, & !  7
-                                 1.00_wp, 0.00_wp, 0.00_wp, 0.00_wp, & !  8
-                                 0.47_wp, 0.45_wp, 0.08_wp, 0.00_wp, & !  9
-                                 0.24_wp, 0.41_wp, 0.31_wp, 0.04_wp, & ! 10
-                                 0.17_wp, 0.31_wp, 0.33_wp, 0.19_wp, & ! 11
-                                 0.00_wp, 0.00_wp, 0.00_wp, 0.00_wp, & ! 12
-                                 0.25_wp, 0.34_wp, 0.27_wp, 0.11_wp, & ! 13
-                                 0.00_wp, 0.00_wp, 0.00_wp, 0.00_wp, & ! 14
-                                 0.00_wp, 0.00_wp, 0.00_wp, 0.00_wp, & ! 15
-                                 0.23_wp, 0.36_wp, 0.30_wp, 0.11_wp, & ! 16 
-                                 0.23_wp, 0.36_wp, 0.30_wp, 0.11_wp, & ! 17 
-                                 0.19_wp, 0.35_wp, 0.36_wp, 0.10_wp, & ! 18
-                                 0.19_wp, 0.35_wp, 0.36_wp, 0.10_wp  & ! 19
+    REAL(wp), DIMENSION(0:3,1:19), PARAMETER :: root_distribution = RESHAPE( (/ &
+                                 0.24_wp, 0.41_wp, 0.31_wp, 0.04_wp,            & !  1
+                                 0.35_wp, 0.38_wp, 0.23_wp, 0.04_wp,            & !  2
+                                 0.26_wp, 0.39_wp, 0.29_wp, 0.06_wp,            & !  3
+                                 0.26_wp, 0.38_wp, 0.29_wp, 0.07_wp,            & !  4
+                                 0.24_wp, 0.38_wp, 0.31_wp, 0.07_wp,            & !  5
+                                 0.25_wp, 0.34_wp, 0.27_wp, 0.14_wp,            & !  6
+                                 0.27_wp, 0.27_wp, 0.27_wp, 0.09_wp,            & !  7
+                                 1.00_wp, 0.00_wp, 0.00_wp, 0.00_wp,            & !  8
+                                 0.47_wp, 0.45_wp, 0.08_wp, 0.00_wp,            & !  9
+                                 0.24_wp, 0.41_wp, 0.31_wp, 0.04_wp,            & ! 10
+                                 0.17_wp, 0.31_wp, 0.33_wp, 0.19_wp,            & ! 11
+                                 0.00_wp, 0.00_wp, 0.00_wp, 0.00_wp,            & ! 12
+                                 0.25_wp, 0.34_wp, 0.27_wp, 0.11_wp,            & ! 13
+                                 0.00_wp, 0.00_wp, 0.00_wp, 0.00_wp,            & ! 14
+                                 0.00_wp, 0.00_wp, 0.00_wp, 0.00_wp,            & ! 15
+                                 0.23_wp, 0.36_wp, 0.30_wp, 0.11_wp,            & ! 16 
+                                 0.23_wp, 0.36_wp, 0.30_wp, 0.11_wp,            & ! 17 
+                                 0.19_wp, 0.35_wp, 0.36_wp, 0.10_wp,            & ! 18
+                                 0.19_wp, 0.35_wp, 0.36_wp, 0.10_wp             & ! 19
                                  /), (/ 4, 19 /) )
 
@@ -429,5 +428,5 @@
 !
 !-- Soil parameters I           alpha_vg,      l_vg,    n_vg, gamma_w_sat
-    REAL(wp), DIMENSION(0:3,1:7) :: soil_pars = RESHAPE( (/                &
+    REAL(wp), DIMENSION(0:3,1:7), PARAMETER :: soil_pars = RESHAPE( (/     &
                                  3.83_wp,  1.250_wp, 1.38_wp,  6.94E-6_wp, & ! 1
                                  3.14_wp, -2.342_wp, 1.28_wp,  1.16E-6_wp, & ! 2
@@ -441,5 +440,5 @@
 !
 !-- Soil parameters II              m_sat,     m_fc,   m_wilt,    m_res  
-    REAL(wp), DIMENSION(0:3,1:7) :: m_soil_pars = RESHAPE( (/            &
+    REAL(wp), DIMENSION(0:3,1:7), PARAMETER :: m_soil_pars = RESHAPE( (/ &
                                  0.403_wp, 0.244_wp, 0.059_wp, 0.025_wp, & ! 1
                                  0.439_wp, 0.347_wp, 0.151_wp, 0.010_wp, & ! 2
@@ -490,5 +489,4 @@
 !-- Public prognostic variables
     PUBLIC m_liq_eb, m_liq_eb_av, m_soil, m_soil_av, t_soil, t_soil_av
-
 
     INTERFACE init_lsm
@@ -573,4 +571,5 @@
        ALLOCATE ( qsws_liq_eb(nysg:nyng,nxlg:nxrg) )
        ALLOCATE ( qsws_veg_eb(nysg:nyng,nxlg:nxrg) )
+       ALLOCATE ( rad_net_l(nysg:nyng,nxlg:nxrg) )
        ALLOCATE ( r_a(nysg:nyng,nxlg:nxrg) )
        ALLOCATE ( r_canopy(nysg:nyng,nxlg:nxrg) )
@@ -583,5 +582,5 @@
 #if ! defined( __nopointer )
 !
-!-- Initial assignment of the pointers
+!--    Initial assignment of the pointers
        t_soil    => t_soil_1;    t_soil_p    => t_soil_2
        t_surface => t_surface_1; t_surface_p => t_surface_2
@@ -890,4 +889,5 @@
 !
 !--    Add timeseries for land surface model
+
        dots_label(dots_num+1) = "ghf_eb"
        dots_label(dots_num+2) = "shf_eb"
@@ -904,5 +904,4 @@
        dots_soil = dots_num + 1
        dots_num  = dots_num + 8
-
 
        RETURN
@@ -957,4 +956,5 @@
        exn = ( surface_pressure / 1000.0_wp )**0.286_wp
 
+       
 
        DO i = nxlg, nxrg
@@ -984,7 +984,8 @@
 !--          f1: correction for incoming shortwave radiation (stomata close at 
 !--          night)
-             IF ( irad_scheme /= 0 )  THEN
-                f1 = MIN(1.0_wp, ( 0.004_wp * rad_sw_in(j,i) + 0.05_wp ) /     &
-                              (0.81_wp * (0.004_wp * rad_sw_in(j,i) + 1.0_wp) ))
+             IF ( radiation_scheme /= 'constant' )  THEN
+                f1 = MIN( 1.0_wp, ( 0.004_wp * rad_sw_in(k,j,i) + 0.05_wp ) /&
+                              (0.81_wp * (0.004_wp * rad_sw_in(k,j,i)        &
+                               + 1.0_wp)) )
              ELSE
                 f1 = 1.0_wp
@@ -1112,5 +1113,5 @@
 !
 !--          Add LW up so that it can be removed in prognostic equation
-             rad_net(j,i) = rad_net(j,i) + sigma_sb * t_surface(j,i) ** 4
+             rad_net_l(j,i) = rad_net(j,i) + sigma_sb * t_surface(j,i) ** 4
 
              IF ( humidity )  THEN
@@ -1118,5 +1119,5 @@
 !
 !--             Numerator of the prognostic equation
-                coef_1 = rad_net(j,i) + 3.0_wp * sigma_sb * t_surface(j,i) ** 4&
+                coef_1 = rad_net_l(j,i) + 3.0_wp * sigma_sb * t_surface(j,i) ** 4&
                          + f_shf / exn * T_1 + f_qsws * ( q_p(k+1,j,i) - q_s   &
                          + dq_s_dt * t_surface(j,i) ) + lambda_surface         &
@@ -1132,5 +1133,5 @@
 !
 !--             Numerator of the prognostic equation
-                coef_1 = rad_net(j,i) + 3.0_wp * sigma_sb * t_surface(j,i) ** 4&
+                coef_1 = rad_net_l(j,i) + 3.0_wp * sigma_sb * t_surface(j,i) ** 4&
                          + f_shf / exn * T_1 + lambda_surface                  &
                          * t_soil(nzb_soil,j,i)
@@ -1175,5 +1176,5 @@
 !
 !--          Calculate fluxes
-             rad_net(j,i)   = rad_net(j,i) + 3.0_wp * sigma_sb                 &
+             rad_net_l(j,i)   = rad_net_l(j,i) + 3.0_wp * sigma_sb                 &
                               * t_surface(j,i)**4 - 4.0_wp * sigma_sb          &
                               * t_surface(j,i)**3 * t_surface_p(j,i)
@@ -1621,14 +1622,4 @@
           CASE ( 0 )
 
-             t_surface = t_surface_p
-             t_soil    = t_soil_p
-             IF ( humidity )  THEN
-                m_soil    = m_soil_p
-                m_liq_eb  = m_liq_eb_p
-             ENDIF
-
-
-          CASE ( 1 )
-
              t_surface  => t_surface_1; t_surface_p  => t_surface_2
              t_soil     => t_soil_1;    t_soil_p     => t_soil_2
@@ -1638,4 +1629,14 @@
              ENDIF
 
+
+          CASE ( 1 )
+
+             t_surface  => t_surface_2; t_surface_p  => t_surface_1
+             t_soil     => t_soil_2;    t_soil_p     => t_soil_1
+             IF ( humidity )  THEN
+                m_soil    => m_soil_2;   m_soil_p    => m_soil_1
+                m_liq_eb  => m_liq_eb_2; m_liq_eb_p  => m_liq_eb_1
+             ENDIF
+
        END SELECT
 #endif
Index: palm/trunk/SOURCE/netcdf.f90
===================================================================
--- palm/trunk/SOURCE/netcdf.f90	(revision 1584)
+++ palm/trunk/SOURCE/netcdf.f90	(revision 1585)
@@ -148,4 +148,7 @@
     USE profil_parameter,                                                       &
         ONLY:  crmax, cross_profiles, dopr_index,profile_columns, profile_rows
+
+    USE radiation_model_mod,                                                    &
+        ONLY:  rad_lw_in, rad_lw_out, rad_sw_in, rad_sw_out
 
     USE spectrum,                                                               &
@@ -523,5 +526,6 @@
                 CASE ( 'e', 'lpt', 'nr', 'p', 'pc', 'pr', 'prr', 'pt', 'q',&
                        'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv',    &
-                       'rho', 's', 'sa', 'vpt' )
+                       'rho', 's', 'sa', 'vpt', 'rad_lw_in', 'rad_lw_out', &
+                       'rad_sw_in', 'rad_sw_out' )
 
                    grid_x = 'x'
@@ -1103,5 +1107,6 @@
                 CASE ( 'e', 'lpt', 'nr', 'p', 'pc', 'pr', 'prr', 'pt', 'q',   &
                        'qc', 'ql', 'ql_c', 'ql_v', 'ql_vp', 'qr', 'qv', 'rho',&
-                       's', 'sa', 'vpt' )
+                       's', 'sa', 'vpt' , 'rad_lw_in', 'rad_lw_out',          &
+                       'rad_sw_in', 'rad_sw_out' )
 
                    grid_x = 'x'
@@ -1756,5 +1761,6 @@
                              'prr_xy', 'pt_xy', 'q_xy', 'qc_xy', 'ql_xy',        &
                              'ql_c_xy', 'ql_v_xy', 'ql_vp_xy', 'qr_xy', 'qv_xy', &
-                             'rho_xy', 's_xy', 'sa_xy', 'vpt_xy' )
+                             'rho_xy', 's_xy', 'sa_xy', 'vpt_xy', 'rad_lw_in_xy',&
+                             'rad_lw_out_xy', 'rad_sw_in_xy', 'rad_sw_out_xy' )
 
                          grid_x = 'x'
@@ -2439,5 +2445,6 @@
                           'prr_xz', 'pt_xz', 'q_xz', 'qc_xz', 'ql_xz',         &
                           'ql_c_xz', 'ql_v_xz', 'ql_vp_xz', 'qr_xz', 'qv_xz',  &
-                          'rho_xz', 's_xz', 'sa_xz', 'vpt_xz' )
+                          'rho_xz', 's_xz', 'sa_xz', 'vpt_xz' , 'rad_lw_in_xz',&
+                             'rad_lw_out_xz', 'rad_sw_in_xz', 'rad_sw_out_xz' )
 
                       grid_x = 'x'
@@ -3115,5 +3122,6 @@
                           'prr_yz', 'pt_yz', 'q_yz', 'qc_yz', 'ql_yz',        &
                           'ql_c_yz', 'ql_v_yz', 'ql_vp_yz', 'qr_yz', 'qv_yz', &
-                          'rho_yz', 's_yz', 'sa_yz', 'vpt_yz' )
+                          'rho_yz', 's_yz', 'sa_yz', 'vpt_yz', 'rad_lw_in_yz',&
+                             'rad_lw_out_yz', 'rad_sw_in_yz', 'rad_sw_out_yz' )
 
                       grid_x = 'x'
Index: palm/trunk/SOURCE/package_parin.f90
===================================================================
--- palm/trunk/SOURCE/package_parin.f90	(revision 1584)
+++ palm/trunk/SOURCE/package_parin.f90	(revision 1585)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Added several radiation_par parameters
 !
 ! Former revisions:
@@ -144,6 +144,8 @@
 
     USE radiation_model_mod,                                                   &
-        ONLY: albedo, day_init, dt_radiation, lambda, net_radiation, radiation,&
-              radiation_scheme, time_radiation, time_utc_init 
+        ONLY: albedo, albedo_type, albedo_lw_dif, albedo_lw_dir, albedo_sw_dif,&
+              albedo_sw_dir, day_init, constant_albedo, dt_radiation, lambda,  &
+              lw_radiation, net_radiation, radiation, radiation_scheme,        &
+              sw_radiation, time_utc_init
                 
 
@@ -221,6 +223,9 @@
                                   write_particle_statistics
 
-    NAMELIST /radiation_par/      albedo, day_init, dt_radiation, lambda,      &
-                                  net_radiation, radiation_scheme, time_utc_init 
+    NAMELIST /radiation_par/      albedo, albedo_type, albedo_lw_dir,          &
+                                  albedo_lw_dif, albedo_sw_dir, albedo_sw_dif, &
+                                  constant_albedo, day_init, dt_radiation,     &
+                                  lambda, lw_radiation, net_radiation,         &
+                                  radiation_scheme, sw_radiation, time_utc_init 
 
     NAMELIST /spectra_par/        averaging_interval_sp, comp_spectra_level,   &
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 1584)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 1585)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-!
+! Added call for temperature tendency calculation due to radiative flux divergence
 ! 
 ! Former revisions:
@@ -277,4 +277,7 @@
         ONLY:  production_e, production_e_acc
 
+    USE radiation_model_mod,                                                   &
+        ONLY:  radiation, radiation_scheme, radiation_tendency
+
     USE statistics,                                                            &
         ONLY:  hom
@@ -593,4 +596,11 @@
                 CALL subsidence( i, j, tend, pt, pt_init, 2 )
              ENDIF
+
+!
+!--          If required, add tendency due to radiative heating/cooling
+             IF ( radiation .AND. radiation_scheme == 'rrtmg' )  THEN
+                CALL radiation_tendency ( i, j, tend )
+             ENDIF
+
 
              CALL user_actions( i, j, 'pt-tendency' )
@@ -1246,4 +1256,10 @@
             .NOT. use_subsidence_tendencies )  THEN
           CALL subsidence( tend, pt, pt_init, 2 )
+       ENDIF
+
+!
+!--    If required, add tendency due to radiative heating/cooling
+       IF ( radiation .AND. radiation_scheme == 'rrtmg' )  THEN
+          CALL radiation_tendency ( tend )
        ENDIF
 
